#include <Arduino.h>

#ifndef MAIN_H
#define MAIN_H

#define SETUP_PROGRESS_MAX 8

#include <Preferences.h>
extern Preferences prefs;
extern bool scroller;
extern bool rainbow;

#include <FastLED.h>
#include <RGBW.h>

void writeText(const char[]);
void fillColorW(uint8_t r, uint8_t g, uint8_t b, uint8_t w);
void fillColor(uint8_t r, uint8_t g, uint8_t b);

void progress(uint8 progress, uint8 total, uint8 r, uint8 g, uint8 b);
void add_progress();
void progress_color(uint8 r, uint8 g, uint8 b);
void set_progress(uint8 x, uint8 of);
void show_progress();
void fill_stripes(CRGB, CRGB, CRGB, CRGB, CRGB);
void fillColorFT(int from, int to, CRGB color);
void set_pixelw(int p, CRGBW);
void show_pixel();

#endif // MAIN_H