// SERVER.h
#ifndef SERVER_H
#define SERVER_H

#include <ESP8266WiFi.h>
#include <ESP8266WebServer.h>
#include <WiFiClientSecure.h> // websocket needs and doesnt include itself :/
#include <ESP8266mDNS.h>
#include <Updater.h>
#include <WebSocketsServer.h>

// TODO: #include <Update.h>

void connectToWiFi();
void setupWebServer();
void handleWebClient();
void handleTickerEvent();
void handleUDP();

extern ESP8266WebServer server;
extern WebSocketsServer webSocket;

extern bool enableFallbackAP;

#endif // SERVER_H