#ifndef CONFIG_H
#define CONFIG_H

#include <Arduino.h>

#define lenlines 38

extern char *lines[];
extern const size_t num_lines;

#define NUM_LEDS 90
#define DATA_PIN D4

// HSV Modifier between leds
#define HSVM 10

#define FALLBACK_SSID "zugdingens"
#define FALLBACK_PASSWORD "immernochbesseralspeter"

#define HOST "zugdingens"

#define FALLBACK_IP IPAddress(10, 0, 0, 254)
#define GATEWAY_IP IPAddress(10, 0, 0, 254)
#define SUBNET_IP IPAddress(255, 255, 255, 0)

#define UDP_PORT 4210

#endif // CONFIG_H